package cn.iocoder.yudao.module.inspection.service;

import cn.iocoder.yudao.module.inspection.entity.InspectionWorkNode;
import cn.iocoder.yudao.module.inspection.query.OrderTableQuery;
import cn.iocoder.yudao.module.inspection.vo.DlInspectionWorkNodeVo;
import cn.iocoder.yudao.module.system.dal.dataobject.permission.RoleDO;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import cn.iocoder.yudao.module.inspection.entity.InspectionInfo;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * 【请填写功能名称】Service接口
 *
 * @author ruoyi
 * @date 2023-08-13
 */
public interface IInspectionInfoService  extends IService<InspectionInfo>
{
    /**
     * 查询【请填写功能名称】
     *
     * @param id 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
    public InspectionInfo selectInspectionInfoById(Long id);

    /**
     * 查询【请填写功能名称】列表
     *
     * @param inspectionInfo 【请填写功能名称】
     * @return 【请填写功能名称】集合
     */
    public IPage<InspectionInfo> selectInspectionInfoList(Page<InspectionInfo> page, InspectionInfo inspectionInfo);

    /**
     * 新增【请填写功能名称】
     *
     * @param inspectionInfo 【请填写功能名称】
     * @return 结果
     */
    public int insertInspectionInfo(InspectionInfo inspectionInfo) throws Exception;
    void settleAccounts(Long InspectionId);
    /**
     * 修改【请填写功能名称】
     *
     * @param inspectionInfo 【请填写功能名称】
     * @return 结果
     */
    public int updateInspectionInfo(InspectionInfo inspectionInfo) throws Exception;
    /**
     * 修改引车员
     *
     * @param inspectionInfo 【请填写功能名称】
     * @return 结果
     */
    public int updateLeadMan(InspectionInfo inspectionInfo);

    /**
     * 批量删除【请填写功能名称】
     *
     * @param ids 需要删除的【请填写功能名称】主键集合
     * @return 结果
     */
    public int deleteInspectionInfoByIds(Long ids);

    /**
     * 删除【请填写功能名称】信息
     *
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
    public int deleteInspectionInfoById(Long id);

    List<InspectionInfo> workOrder(Long partnerId, String carNum, String goodsTitle, String customerSource, String payType, String startTime, Long roleId, String endTime);

    IPage<InspectionInfo> pageWorkOrder(Long partnerId, String carNum, String goodsTitle, String customerSource, String payType, String startTime, Long roleId, String endTime,Page<InspectionInfo> page);
    IPage<InspectionInfo> pageWorkOrder(OrderTableQuery query, Page<InspectionInfo> page);


    List<InspectionInfo> delworkOrder(Long partnerId, String carNum, String goodsTitle,String customerSource,String payType,String startTime,Long roleId,String endTime);

    IPage<InspectionInfo> pageDelWorkOrder(Long partnerId, String carNum, String goodsTitle, String customerSource, String payType, String startTime, Long roleId, String endTime,Page<InspectionInfo> page);

    Map<String,Object> workOrderData(Long partnerId, String carNum, String goodsTitle, String customerSource, String payType, String startTime, Long roleId, String endTime);
    Map<String,Object> workOrderData(OrderTableQuery query);

    /**
     * 根据当前登陆人获取可以选择的工单
     * @return
     */
    IPage<InspectionInfo> geStelectInspection(IPage page,InspectionInfo inspectionInfo);

    /**
     * 获取工单详情
     * @param id
     * @return
     */
    DlInspectionWorkNodeVo getWorkNode(Integer inspectionId, String workNodeId);

    /**
     * 根据工单id获取工单流程
     * @param inspectionId
     * @return
     */
    List<InspectionWorkNode> getWeorkNodesById(Integer inspectionId);

    /**
     * 判断app当前检测人是否有审核权限
     * @return
     */
    Boolean isExamine(String code);

    /**
     * 获取某个工单针对当前操作用户，某个状态的项目们
     *
     * @author 小李
     * @date 10:48 2024/12/11
     * @param id 工单ID
     * @param status 状态
     **/
    Map<String, String> getWorkNodeByIdAndNow(Long id, String status, Boolean flag);

    /**
     * 判断是否可以修改引车员
     *
     * @author 小李
     * @date 15:22 2024/12/11
     * @param id 工单ID
     **/
    Boolean judgeUpdateLeadMan(Long id);

    /**
     * 获取当前登陆人的角色列表
     * @return
     */
    List<RoleDO> getRoleList();

    String easyPoiExport(String templatePath, String filename, Map<String, Object> data, HttpServletRequest request, HttpServletResponse response);

    /**
     * 获得不同状态的数据的数量
     *
     * @author 小李
     * @date 16:22 2024/12/18
     **/
    Map<String, Long> getCountByType(Integer partnerId);

    /**
     * 接车拍照
     * @param inspectionWorkNode
     */
    Boolean meetCarPhoto(InspectionWorkNode inspectionWorkNode);

    /**
     * 还车拍照
     * @param inspectionWorkNode
     */
    Boolean returnCarPhoto(InspectionWorkNode inspectionWorkNode);

    /**
     * 引车
     * @param inspectionInfo
     */
    void leadCar(InspectionInfo inspectionInfo);

    /**
     * 获取业务方工单
     * @param page
     * @param inspectionInfo
     * @return
     */
    IPage<InspectionInfo> geStelectInspectionByBusiness(Page<InspectionInfo> page, InspectionInfo inspectionInfo);

    Map<String, Long>  getBusinessCountByType(Integer partnerId, List<String> datetimeRange);

    List<InspectionInfo> selectMeetCarList(List<String> datetimeRange, String goodsTitle);

    List<InspectionInfo> selectLatestByCarNums(Collection<String> carNos);

    Map<Long, Long> selectBuyUserIdsByInfoIds(Collection<Long> ids);
}
